#pragma once

#include "NPCommonUI.h"
#include "Object.h"

class NPCOMMONUI_API AbstractCommand : public Object
{
public:
	AbstractCommand(void);
	virtual ~AbstractCommand(void);

	virtual BOOL Execute();
	/*! \brief : undo */
	virtual BOOL Undo();
	///< redo
	virtual BOOL Redo() { return Execute(); }
	
	///< can undo
	virtual BOOL CanUndo() { return FALSE; }
	/**
	* @brief	can redo
	* @return	BOOL
	*/
	virtual BOOL CanRedo() { return FALSE; }
protected:
	virtual BOOL ExecuteImpl() = 0;
	virtual void ExecuteLog() {}
	virtual BOOL UndoImpl() { return FALSE; }
	virtual void UndoLog() {}
};
